<?php

namespace App\Controller;

use App\Data\TacticInfo;
use App\Gateway\TacticInfoGateway;
use App\HttpCodes;
use App\Model\TacticModel;

class EditorController {


    private TacticModel $model;

    /**
     * @param TacticModel $model
     */
    public function __construct(TacticModel $model) {
        $this->model = $model;
    }

    private function openEditor(TacticInfo $tactic) {
        send_react_front("views/Editor.tsx", ["name" => $tactic->getName(), "id" => $tactic->getId()]);
    }

    public function makeNew() {
        $tactic = $this->model->makeNewDefault();
        $this->openEditor($tactic);
    }

    public function edit(int $id) {
        $tactic = $this->model->get($id);

        if ($tactic == null) {
            http_response_code(404);
            echo "la tactique " . $id . " n'existe pas";
            return;
        }

        $this->openEditor($tactic);
    }

}