<?php

namespace App\Validation;

/**
 * A collection of standard validators
 */
class Validators {


    /**
     * @return Validator a validator that validates strings that does not contain invalid chars such as `<` and `>`
     */
    public static function noInvalidChars(): Validator {
        return new SimpleFunctionValidator(
            fn($str) => !filter_var($str, FILTER_VALIDATE_REGEXP, ['options' => ["regexp" => "/[<>]/"]]),
            fn(string $name) => FieldValidationFail::invalidChars($name)
        );
    }

    /**
     * @return Validator a validator that validates non-empty strings
     */
    public static function nonEmpty(): Validator {
        return new SimpleFunctionValidator(
            fn($str) => !empty($str),
            fn(string $name) => FieldValidationFail::empty($name)
        );
    }


}


